[ Avaa Bypassed ]




Upload:

Command:

hmhc3928@18.219.158.84: ~ $
#!/bin/bash
#
# new-kernel-pkg
# Invoked upon installation or removal of a kernel package, the following
# tasks are/can be done here:
# creation/removal of initrd
# run of depmod/removal of depmod generated files
# addition/removal of kernel images from grub/lilo configuration (via grubby)
#
# Copyright 2002-2008 Red Hat, Inc.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

PATH=/sbin:/bin:$PATH

lilo=/sbin/lilo

# some defaults that are sane for most arches
kernelName=vmlinuz

if [ -x ./grubby ]; then
    grubby=./grubby
else
    grubby=/sbin/grubby
fi

[ -f /etc/sysconfig/kernel ] && . /etc/sysconfig/kernel
[ -f /etc/sysconfig/uboot ] && . /etc/sysconfig/uboot

cfgGrub2=""
cfgGrub2Efi=""
cfgGrub=""
cfgLilo=""
cfgExtlinux=""
cfguBoot=""
runLilo=""
grubConfig=""
grub2Config=""
grub2EfiConfig=""
extlinuxConfig=""
ubootScript="/boot/boot.scr"

ARCH=$(uname -m)

if [ $ARCH = 'ia64' ]; then
    liloConfig=/boot/efi/EFI/redhat/elilo.conf
    bootPrefix=/boot/efi/EFI/redhat
    liloFlag=elilo
    isx86=""
elif [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then
    liloConfig=/etc/yaboot.conf
    grub2Config=$(readlink -f /etc/grub2.cfg 2>/dev/null)
    bootPrefix=/boot
    lilo=/sbin/ybin
    liloFlag=yaboot
    runLilo="yes"
    isx86=""
elif [ $ARCH = 'sparc' -o $ARCH = 'sparc64' ]; then
    liloConfig=/etc/silo.conf
    bootPrefix=/boot
    liloFlag=silo
    lilo=/sbin/silo
    isx86=""
elif [ $ARCH = 's390' -o $ARCH = 's390x' ]; then
    liloConfig=/etc/zipl.conf
    bootPrefix=/boot
    liloFlag=zipl
    lilo=/sbin/zipl
    runLilo="yes"
    isx86=""
elif [[ ${ARCH} =~ armv[5|7].*l ]] ; then
    liloConfig=""
    bootPrefix=/boot
    extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
    ubootDir=${UBOOT_DIR:-"/boot"}
    ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
    ubootKList=${UBOOT_KLIST:-"klist.txt"}
    ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
    ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
    ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
    ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
    mounted=""
    liloFlag=""
    isx86=""
else
    # this leaves i?86 and x86_64
    liloConfig=/etc/lilo.conf
    grubConfig=$(readlink -f /etc/grub.conf 2>/dev/null)
    grub2Config=$(readlink -f /etc/grub2.cfg 2>/dev/null)
    grub2EfiConfig=$(readlink -f /etc/grub2-efi.cfg 2>/dev/null)
    extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
    bootPrefix=/boot
    liloFlag=lilo
    isx86="yes"
fi

mode=""
version=""
initrd=""
dracut=""
dracuthostonly=""
initrdfile=""
devtreefile=""
moddep=""
verbose=""
makedefault=""
package=""
mbkernel="$HYPERVISOR"
mbargs="$HYPERVISOR_ARGS"
adddracutargs=""
addplymouthinitrd=""
DEBUGARG="systemd.log_level=debug systemd.log_target=kmsg"

usage() {
    echo "Usage: `basename $0` [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
    echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
    echo "       [--kernel-args=<args>] [--remove-args=<args>]" >&2
    echo "       [--banner=<banner>] [--multiboot=multiboot]" >&2
    echo "       [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
    echo "       [--add-plymouth-initrd]" >&2
    echo "       [--host-only] [--devtree=<devicetree.dtb>]" >&2
    echo "       <--install | --remove | --update | --rpmposttrans> <kernel-version>" >&2
    echo "       (ex: `basename $0` --mkinitrd --depmod --install 2.4.7-2)" >&2
    exit 1
}

rungrubby() {
	if [ "$1" == "--debug" ]; then
		[ "$MAKEDEBUG" != "yes" ] && return 0
		[ -n "$verbose" ] && echo "- First, making a debug entry."
		if [ $ARCH = 's390' -o $ARCH = 's390x' ]; then
			declare -x debugtitle="_with_debugging"
		else
			declare -x debugtitle=" with debugging"
		fi
		declare -x debugargs="$DEBUGARG"
		shift
	else
		[ -n "$verbose" ] && echo "- Making a normal entry."
	fi
	$(eval $grubby $@)
	export -n debugargs
	export -n debugtitle
	unset debugargs
	unset debugtitle
}

set_title() {
    if [ -n "$banner" ]; then
	if [ $ARCH = 's390' -o $ARCH = 's390x' ]; then
	    title=$(echo $banner | sed 's/ /_/g')
	else
	    title="$banner ($version)"
	fi
    elif [ $ARCH = 's390' -o $ARCH = 's390x' ]; then
	title=$(echo $version | sed 's/ /_/g')
    elif [ -f /etc/os-release ]; then
	. /etc/os-release
	title="$NAME ($version) $VERSION"
    elif [ -f /etc/redhat-release ]; then
	title="$(sed 's/ release.*$//' < /etc/redhat-release) ($version)"
    else
	title="Red Hat Linux ($version)"
    fi
}

install() {
    # XXX kernel should be able to be specified also (or work right on ia64)
    if [ ! -f $kernelImage ] ; then
	[ -n "$verbose" ] && echo "kernel for $version does not exist, not running grubby"
	return
    fi

    INITRD=""
    if [ -f $initrdfile ]; then
	[ -n "$verbose" ] && echo "found $initrdfile and using it with grubby"
	INITRD="--initrd $initrdfile"

	if [ -n "$addplymouthinitrd" ]; then
	    INITRD="$INITRD --extra-initrd $bootPrefix/initrd-plymouth.img"
	fi
    fi

    DEVTREE=""
    if [ "x$devtreefile" != "x" -a -f "$devtreefile" ]; then
	[ -n "$verbose" ] && echo "found $devtreefile and using it with grubby"
	DEVTREE="--devtree $devtreefile"
    fi

    # FIXME: is this a good heuristic to find out if we're on iSeries?
    if [ -d /proc/iSeries ]; then
	[ -n "$verbose" ] && echo "On an iSeries, just making img file"
	if [ -z $initrdfile  ]; then
	    [ -n "$verbose" ] && echo "No initrd, just adding system map"
	    /sbin/addSystemMap $bootPrefix/System.map-$version $kernelImage $bootPrefix/vmlinitrd-$version
	else
	    /sbin/addSystemMap $bootPrefix/System.map-$version $kernelImage $bootPrefix/vmlinux.sm-$version
	    /sbin/addRamDisk $initrdfile $bootPrefix/System.map-$version $bootPrefix/vmlinux.sm-$version $bootPrefix/vmlinitrd-$version 2>/dev/null
	    rm $bootPrefix/vmlinux.sm-$version
	fi
	return
    fi

    # get the root filesystem to use
    rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab 2>/dev/null)
    if [ "$rootdevice" = "" ];
    then
	    rootdevice=`grep -o -P "(?<=root=)\S+" /proc/cmdline`
    fi

    if [ -n "$mbkernel" -a -n "$cfgLilo" -a "$liloFlag" != "elilo" ]; then
	[ -n "$verbose" ] && echo "multiboot specified, not updating lilo.conf"
	cfgLilo=""
    fi

    set_title

    if [ -n "$cfgGrub" ]; then
	[ -n "$verbose" ] && echo "adding $version to $grubConfig"

	ARGS="--grub -c $grubConfig --add-kernel=$kernelImage $INITRD \
		${mbkernel:+--add-multiboot=\"$mbkernel\"} \
		${mbargs:+--mbargs=\"$mbargs\"} \
		--title=\"$title\$debugtitle\" --copy-default \
		--args=\"root=$rootdevice $kernargs \$debugargs\" \
		--remove-kernel=\"TITLE=$title\$debugtitle\""

	rungrubby ${ARGS} $makedefault
	rungrubby --debug ${ARGS} --set-index=1
    else
	[ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby for grub 0.97"
    fi
    if [ -n "$cfgGrub2" ]; then
	[ -n "$verbose" ] && echo "adding $version to $grub2Config"

	ARGS="--grub2 -c $grub2Config --add-kernel=$kernelImage $INITRD \
		--copy-default --title \"$title\$debugtitle\" \
		${mbkernel:+--add-multiboot=\"$mbkernel\"} \
		${mbargs:+--mbargs=\"$mbargs\"} \
		--args=\"root=$rootdevice $kernargs \$debugargs\" \
		--remove-kernel=\"TITLE=$title\$debugtitle\""
	rungrubby ${ARGS} $makedefault
	rungrubby --debug ${ARGS} --set-index=1
    else
	[ -n "$verbose" ] && echo "$grub2Config does not exist, not running grubby for grub 2"
    fi
    if [ -n "$cfgGrub2Efi" ]; then
	[ -n "$verbose" ] && echo "adding $version to $grub2EfiConfig"

	ARGS="--grub2 -c $grub2EfiConfig --efi \
		--add-kernel=$kernelImage $DEVTREE $INITRD \
		--copy-default --title \"$title\$debugtitle\" \
		${mbkernel:+--add-multiboot=\"$mbkernel\"} \
		${mbargs:+--mbargs=\"$mbargs\"} \
		--args=\"root=$rootdevice $kernargs \$debugargs\" \
		--remove-kernel=\"TITLE=$title\$debugtitle\""
	rungrubby ${ARGS} $makedefault
	rungrubby --debug ${ARGS} --set-index=1
    else
	[ -n "$verbose" ] && echo "$grub2EfiConfig does not exist, not running grubby for grub 2 with UEFI"
    fi

    if [ -n "$cfgLilo" ]; then
	[ -n "$verbose" ] && echo "adding $version to $liloConfig"

	ARGS="--$liloFlag --add-kernel=$kernelImage $INITRD \
		--copy-default --title \"$title\$debugtitle\" \
		${mbkernel:+--add-multiboot=\"$mbkernel\"} \
		${mbargs:+--mbargs=\"$mbargs\"} \
		--args=\"root=$rootdevice $kernargs \$debugargs\" \
		--remove-kernel=\"TITLE=$version\""

	rungrubby ${ARGS} $makedefault
	rungrubby --debug ${ARGS} --set-index=1
	if [ -n "$runLilo" ]; then
	    [ -n "$verbose" ] && echo "running $lilo"
	    if [ ! -x $lilo ] ; then
		[ -n "$verbose" ] && echo "$lilo does not exist"
	    else
		$lilo > /dev/null
	    fi
	fi
    else
	[ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"
    fi

    if [ -n "$cfgExtlinux" ]; then
	[ -n "$verbose" ] && echo "adding $version to $extlinuxConfig"

	ARGS="--extlinux -c $extlinuxConfig --add-kernel=$kernelImage \
	    $INITRD --copy-default --title \"$title\$debugtitle\" \
	    ${mbkernel:+--add-multiboot=\"$mbkernel\"} \
	    ${mbargs:+--mbargs=\"$mbargs\"} \
	    --args=\"root=$rootdevice $kernargs \$debugargs\" \
	    --remove-kernel=\"TITLE=$title\$debugtitle\""

	rungrubby ${ARGS} $makedefault
	rungrubby --debug ${ARGS} --set-index=1
    else
	[ -n "$verbose" ] && echo "$extlinuxConfig does not exist, not running grubby for extlinux"
    fi
}

rpmposttrans()
{
    local files
    local f
    files="/etc/kernel/postinst.d/*[^~] /etc/kernel/postinst.d/$version/*[^~]"
    for f in $files ; do
	[ -f $f ] && [ -x $f ] || continue
	$f $version $kernelImage
    done
}

remove() {
    # FIXME: is this a good heuristic to find out if we're on iSeries?
    if [ -d /proc/iSeries ]; then
	[ -n "$verbose" ] && echo "On an iSeries, remove img file"
	rm -f $kernelImage.img 2>/dev/null
	return
    fi

    local files
    local f
    files="/etc/kernel/prerm.d/*[^~] /etc/kernel/prerm.d/$version/*[^~]"
    for f in $files ; do
	[ -f $f ] && [ -x $f ] || continue
	$f $version $kernelImage
    done

    if [ -n "$cfgGrub" ]; then
	[ -n "$verbose" ] && echo "removing $version from $grubConfig"
	$grubby --grub -c $grubConfig \
	    --remove-kernel=$kernelImage
    else
	[ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby for grub 0.97"
    fi
    if [ -n "$cfgGrub2" ]; then
	[ -n "$verbose" ] && echo "removing $version from $grub2Config"
	$grubby --grub2 -c $grub2Config \
		--remove-kernel=$kernelImage
    else
	[ -n "$verbose" ] && echo "$grub2Config does not exist, not running grubby for grub 2"
    fi
    if [ -n "$cfgGrub2Efi" ]; then
	[ -n "$verbose" ] && echo "removing $version from $grub2EfiConfig"
	$grubby --grub2 -c $grub2EfiConfig --efi \
		--remove-kernel=$kernelImage
    else
	[ -n "$verbose" ] && echo "$grub2EfiConfig does not exist, not running grubby grub 2 with UEFI"
    fi

    if [ -n "$cfgLilo" ]; then
	[ -n "$verbose" ] && echo "removing $version from $liloConfig"
	$grubby --remove-kernel=$kernelImage	    \
		     --$liloFlag

	if [ -n "$runLilo" ]; then
	    [ -n "$verbose" ] && echo "running $lilo"
	    if [ ! -x $lilo ] ; then
		[ -n "$verbose" ] && echo "$lilo does not exist"
	    else
		$lilo > /dev/null
	    fi
	fi
    else
	[ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"
    fi

    if [ -n "$cfguBoot" ]; then
	[ -n "$verbose" ] && echo "removing $version from $ubootDir..."

	if [ -f $ubootDir/$ubootKList ]; then
	    tmpKList=`mktemp $ubootDir/$ubootKList.XXXX`
	    curversion=`tail -n1 $ubootDir/$ubootKList`
	    sed "/$version$/d" $ubootDir/$ubootKList > $tmpKList
	    newversion=`tail -n1 $tmpKList`
	    if [ -f $ubootDir/uImage-$newversion ] && [ -f $ubootDir/uInitrd-$newversion ]; then
		if [ "$curversion" != "$newversion" ]; then
		    cp -fp $ubootDir/uImage-$newversion $ubootDir/${ubootDefaultImage}
		    if [ $? -ne 0 ]; then
			[ -n "$verbose" ] && echo "copy uImage-$newversion error, default kernel not replaced!" && exit
		    fi
		    cp -fp $ubootDir/uInitrd-$newversion $ubootDir/${ubootDefaultInitrd}
		    if [ $? -ne 0 ]; then
			[ -n "$verbose" ] && echo "copy uInitrd-$newversion error, default Initrd not replaced!" && exit
		    fi
		fi

		[ -n "$verbose" ] && echo "removing uImage-$version"
		if [ -f $ubootDir/uImage-$version ]; then
		    rm -f $ubootDir/uImage-$version
		else
		    [ -n "$verbose" ] && echo "uImage-$version did not exist!"
		fi

		[ -n "$verbose" ] && echo "removing uInitrd-$version"
		if [ -f $ubootDir/uInitrd-$version ]; then
		    rm -f $ubootDir/uInitrd-$version
		else
		    [ -n "$verbose" ] && echo "uInitrd-$version did not exist!"
		fi

		mv $tmpKList $ubootDir/$ubootKList
		[ -x /sbin/a-b-c ] && /sbin/a-b-c
	    else
		[ -n "$verbose" ] && echo "uImage $newversion does not exist!"
		[ -f $tmpKList ] && rm -f $tmpKList
	    fi
        else
            [ -n "$verbose" ] && echo "No previous kernel version.  U-Boot images not removed!"
        fi
    else
	[ -n "$verbose" ] && echo "$ubootScript does not exist, not modifying $ubootDir"
    fi

    if [ -n "$cfgExtlinux" ]; then
	[ -n "$verbose" ] && echo "removing $version from $extlinuxConfig"
	$grubby --extlinux -c $extlinuxConfig \
	    --remove-kernel=$kernelImage
    else
	[ -n "$verbose" ] && echo "$extlinuxConfig does not exist, not running grubby for extlinux"
    fi
}

update() {
    if [ ! -f $kernelImage ] ; then
	[ -n "$verbose" ] && echo "kernel for $version does not exist, not running grubby"
	return
    fi

    set_title

    INITRD=""
    if [ -f $initrdfile ]; then
	[ -n "$verbose" ] && echo "found $initrdfile and using it with grubby"
	INITRD="--initrd $initrdfile"

	if [ -n "$addplymouthinitrd" ]; then
	    INITRD="$INITRD --extra-initrd $bootPrefix/initrd-plymouth.img"
	fi
    fi

    if [ -n "$cfgGrub" ]; then
	[ -n "$verbose" ] && echo "updating $version from $grubConfig"
	ARGS="--grub -c $grubConfig --update-kernel=$kernelImage $INITRD \
		${kernargs:+--args=\"$kernargs\"} \
		${removeargs:+--remove-args=\"$removeargs\"} \
		${mbkernel:+--add-multiboot=\"$mbkernel\"} \
		--title=\"$title\$debugtitle\""

	rungrubby ${ARGS}
	rungrubby --debug ${ARGS}
    else
	[ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby"
    fi

    if [ -n "$cfgGrub2" ]; then
	[ -n "$verbose" ] && echo "updating $version from $grub2Config"
	ARGS="--grub2 -c $grub2Config --update-kernel=$kernelImage $INITRD \
		${kernargs:+--args=\"$kernargs\"} \
		${removeargs:+--remove-args=\"$removeargs\"} \
		--title=\"$title\$debugtitle\""

	rungrubby ${ARGS}
	rungrubby --debug ${ARGS}
    else
	[ -n "$verbose" ] && echo "$grub2Config does not exist, not running grubby"
    fi

    if [ -n "$cfgGrub2Efi" ]; then
	[ -n "$verbose" ] && echo "updating $version from $grub2EfiConfig"
	ARGS="--grub2 -c $grub2EfiConfig --efi --update-kernel=$kernelImage \
		$INITRD ${kernargs:+--args=\"$kernargs\"} \
		${removeargs:+--remove-args=\"$removeargs\"} \
		--title=\"$title\$debugtitle\""

	rungrubby ${ARGS}
	rungrubby --debug ${ARGS}
    else
	[ -n "$verbose" ] && echo "$grub2EfiConfig does not exist, not running grubby"
    fi

    if [ -n "$cfgLilo" ]; then
	[ -n "$verbose" ] && echo "updating $version from $liloConfig"
	ARGS="--$liloFlag --update-kernel=$kernelImage $INITRD \
		${kernargs:+--args=\"$kernargs\"} \
		${removeargs:+--remove-args=\"$removeargs\"} \
		--title=\"$title\$debugtitle\""

	rungrubby ${ARGS}
	rungrubby --debug ${ARGS}

	if [ -n "$runLilo" ]; then
	    [ -n "$verbose" ] && echo "running $lilo"
	    if [ ! -x $lilo ] ; then
		[ -n "$verbose" ] && echo "$lilo does not exist"
	    else
		$lilo > /dev/null
	    fi
	fi
    else
	[ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"
    fi

    if [ -n "$cfguBoot" ]; then
	[ -n "$verbose" ] && echo "adding $version to $ubootDir..."

	[ -n "$verbose" ] && echo "creating uImage-$version"
	mkimage -A arm -O linux -T kernel -C none -a $ubootAddress \
		-e $ubootAddress -n $version \
		-d $kernelImage $ubootDir/uImage-$version

	[ -n "$verbose" ] && echo "creating uInitrd-$version"
	mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
		-n initramfs -d $initrdfile $ubootDir/uInitrd-$version

	if [ -f $ubootDir/uImage-$version ] && [ -f $ubootDir/uInitrd-$version ]; then
	    cp -fp $ubootDir/uImage-$version $ubootDir/${ubootDefaultImage}
	    if [ $? -ne 0 ]; then
		[ -n "$verbose" ] && echo "copy uImage-$version error, kernel not installed!" && exit
	    fi
	    cp -fp $ubootDir/uInitrd-$version $ubootDir/${ubootDefaultInitrd}
	    if [ $? -ne 0 ]; then
		[ -n "$verbose" ] && echo "copy uInitrd-$version error, kernel not installed!" && exit
	    fi
	    echo $version >> $ubootDir/$ubootKList
	    [ -x /sbin/a-b-c ] && /sbin/a-b-c
	else
	    [ -n "$verbose" ] && echo "cannot make $version the default"
	fi
    else
	[ -n "$verbose" ] && echo "$ubootScript does not exist, not setting up $ubootDir"
    fi

    if [ -n "$cfgExtlinux" ]; then
	[ -n "$verbose" ] && echo "updating $version from $extlinuxConfig"
	ARGS="--extlinux -c $extlinuxConfig --update-kernel=$kernelImage \
		$INITRD ${kernargs:+--args=\"$kernargs\"} \
		${removeargs:+--remove-args=\"$removeargs\"} \
		--title=\"$title\$debugtitle\""

	rungrubby ${ARGS}
	rungrubby --debug ${ARGS}
    else
	[ -n "$verbose" ] && echo "$extlinuxConfig does not exist, not running grubby"
    fi
}

doMkinitrd() {
    if [ -n "$dracut" ]; then
        tool="dracut $dracuthostonly -f $initrdfile $version"
    else
	tool="mkinitrd --allow-missing -f $initrdfile $version"
    fi
    [ -n "$verbose" ] && echo "creating initrd: $tool"
    $tool
    rc=$?
    if [ $rc != 0 ]; then
	echo "mkinitrd failed" >&2
	exit 1
    fi
}

rminitrd() {
    [ -n "$verbose" ] && echo "removing initrd $initrdfile"
    [ -f $initrdfile ] && rm -f $initrdfile
}

doDepmod() {
    [ -n "$verbose" ] && echo "running depmod for $version"
    depmod -ae -F /boot/System.map-$version $version
}

doRmmoddep() {
    [ -n "$verbose" ] && echo "removing modules.dep info for $version"
    if [ -d /lib/modules/$version ]; then
        rm -f /lib/modules/$version/modules.*.bin \
            /lib/modules/$version/modules.{alias,dep,devname,symbols,softdep}
    fi
}

# kernel image for 2.4 is vmlinux
if [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then
  if [ "$kernelmajor" == "2.4" ]; then
      kernelName=vmlinux
  fi
fi

while [ $# -gt 0 ]; do
    case $1 in
	--mkinitrd)
	    initrd="make"
	    ;;

	--rminitrd)
	    initrd="remove"
	    ;;

	--devtree*)
	    if [[ $1 == --devtree\=* ]]; then
		devtreefile=${1#--devtreefile=}
	    else
		devtreefile=$2
		shift
	    fi
	    ;;

	--dracut)
	    dracut=--dracut
	    ;;

	--host-only)
	    dracuthostonly=-H
	    ;;

	--initrdfile*)
	    if [[ $1 == --initrdfile\=* ]]; then
		initrdfile=${1#--initrdfile=}
	    else
		initrdfile=$2
		shift
	    fi
	    ;;

	--kernel-args*)
	    if [[ $1 == --kernel-args\=* ]]; then
		kernargs=${1#--kernel-args=}
	    else
		kernargs=$2
		shift
	    fi
	    ;;

	--remove-args*)
	    if [[ $1 == --remove-args\=* ]]; then
		removeargs=${1#--remove-args=}
	    else
		removeargs=$2
		shift
	    fi
	    ;;

	--banner*)
	    if [[ $1 == --banner\=* ]]; then
		banner=${1#--banner=}
	    else
		banner=$2
		shift
	    fi
	    ;;

	--multiboot*)
	    if [[ $1 == --multiboot\=* ]]; then
		mbkernel=${1#--multiboot=}
	    else
		# can't really support having an optional second arg here
		# sorry!
		mbkernel="/boot/xen.gz"
	    fi
	    ;;

        --mbargs*)
            if [[ $1 == --mbargs\=* ]]; then
                mbargs=${1#--mbargs=}
            else
                mbargs="$2"
                shift
            fi
            ;;

	--depmod)
	    moddep="make"
	    ;;

	--rmmoddep)
	    moddep="remove"
	    ;;

	--make-default)
	    makedefault="--make-default"
	    ;;

        --package*)
            if [[ $1 == --package\=* ]]; then
                package=${1#--package=}
            else
                package=$2
                shift
            fi
            ;;

	--add-dracut-args)
	    adddracutargs=--add-dracut-args
	    ;;

	--add-plymouth-initrd)
	    addplymouthinitrd=--add-plymouth-initrd
	    ;;

        --kernel-image*)
            if [[ $1 == --kernel-image\=* ]]; then
                kernelImage=${1#--kernel-image=}
            else
                kernelImage="$2"
                shift
            fi
            if ! [[ -f $kernelImage ]]; then
                echo "Can't find kernel image '$kernelImage'" >&2
                usage
                exit 1
            fi
            ;;

        --kernel-name*)
            if [[ $1 == --kernel-name\=* ]]; then
                kernelName=${1#--kernel-name=}
            else
                kernelName="$2"
                shift
            fi
            ;;

	-v)
	    verbose=-v
	    ;;

	*)
	    if [ -z "$mode" ]; then
		mode=$1
	    elif [ -z "$version" ]; then
		version=$1
	    else
		usage
	    fi
	    ;;
    esac

    shift
done

# make sure the mode is valid
if [ "$mode" != "--install" -a "$mode" != "--remove"  -a "$mode" != "--update" -a "$mode" != "--rpmposttrans" ] ; then
    usage
fi

if [ -z "$version" ]; then
    usage
fi

if [ "$mode" != "--install" -a "$makedefault" ]; then
    usage
fi

kernelmajor=`echo $kernel | cut -d . -f 1,2`

[[ $kernelImage ]] || kernelImage="$bootPrefix/$kernelName-$version"

# set the initrd file based on arch; ia64 is the only currently known oddball
if [ -z "$initrdfile" ]; then
    INITRD_NAME_PREFIX="initrd"
    if [ -n "$dracut" ]; then
	INITRD_NAME_PREFIX="initramfs"
    fi

    if [ `uname -m` = "ia64" ]; then
	initrdfile="/boot/efi/EFI/redhat/$INITRD_NAME_PREFIX-$version.img"
    else
	initrdfile="/boot/$INITRD_NAME_PREFIX-$version.img"
    fi

fi
[ -n "$verbose" ] && echo "initrdfile is $initrdfile"

# add dracut i18n, keyboard and plymouth kernel args if requested
if [ -n "$dracut" -o -n "$adddracutargs" ]; then
    if [ -r /etc/vconsole.conf ]; then
	. /etc/vconsole.conf
    elif  [ -r /etc/sysconfig/keyboard ]; then
	. /etc/sysconfig/keyboard
    fi

    if [ -r /etc/locale.conf ]; then
	. /etc/locale.conf
    elif [ -r /etc/sysconfig/i18n ]; then
	. /etc/sysconfig/i18n
    fi

    for i in SYSFONT SYSFONTACM UNIMAP LANG KEYTABLE; do
        val=$(eval echo \$$i)
        [ -n "$val" ] && kernargs="$kernargs $i=$val"
    done

    if [ -n "$KEYBOARDTYPE" -a "$KEYBOARDTYPE" != "pc" ]; then
         kernargs="$kernargs KEYBOARDTYPE=$KEYBOARDTYPE"
    fi
fi

# set this as the default if we have the package and it matches
if [ "$mode" == "--install" -a "$UPDATEDEFAULT" == "yes" -a -n "$package" -a -n "$DEFAULTKERNEL" -a "$package" == "$DEFAULTKERNEL" ]; then
    makedefault="--make-default"
    [ -n "$verbose" ] && echo "making it the default based on config"
fi

if [ "$moddep" == "make" ]; then
    doDepmod
elif [ "$moddep" == "remove" ]; then
    doRmmoddep
fi

if [ "$initrd" == "make" ]; then
    doMkinitrd
elif [ "$initrd" == "remove" ]; then
    rminitrd
fi

if [ ! -x $grubby ] ; then
    [ -n "$verbose" ] && echo "$grubby does not exist"
    exit 0
fi


[ -n "$grubConfig" ] && [ -f "$grubConfig" ] && cfgGrub=1;
[ -n "$grub2Config" ] && [ -f "$grub2Config" ] && cfgGrub2=1;
[ -n "$grub2EfiConfig" ] && [ -f "$grub2EfiConfig" ] && cfgGrub2Efi=1;
[ -n "$liloConfig" ] && [ -f "$liloConfig" ] && cfgLilo=1;
[ -n "$extlinuxConfig" ] && [ -f "$extlinuxConfig" ] && cfgExtlinux=1;

# if we have a U-Boot directory, but no boot script, check if the directory
# is mounted.  If not, mount it, and then check if a boot script exists.
if [ -n "$ubootDir" ]; then
    if [ -f "$ubootScript" ]; then
        cfguBoot=1
    else
	mountEntry=`mount | grep $ubootDir`
	if [ -z "$mountEntry" ]; then
	    mount $ubootDevice $ubootDir
	    mounted=1
	fi
	[ -f "$ubootScript" ] && cfguBoot=1;
    fi
fi

# if we're using U-Boot, check if the default load address should change
if [ -n "$cfguBoot" -a -z "$UBOOT_IMGADDR" ]; then
    [[ $version  =~ .([^.]*)$ ]]
    platform=${BASH_REMATCH[1]}
    # A few platforms use an alternate kernel load address
    if [ "$platform" = "omap" ]; then
        ubootAddress=0x80008000
    elif [ "$platform" = "imx" ]; then
        ubootAddress=0x90008000
    fi
fi

# if we have a lilo config on an x86 box, see if the default boot loader
# is lilo to determine if it should be run
if [ -n "$cfgLilo" -a -n "$isx86" ]; then
    runLilo=$($grubby --bootloader-probe | grep lilo)
fi

if [ "$mode" == "--install" ]; then
    install
elif [ "$mode" == "--remove" ]; then
    remove
elif [ "$mode" == "--update" ]; then
    update
elif [ "$mode" == "--rpmposttrans" ]; then
    rpmposttrans
fi

# if we mounted the U-Boot directory, unmount it.
[ -n "$mounted" ] && umount $ubootDir

# make sure changes make it to the disk.
# if /boot is a mountpoint, force the meta data on disk
# to by-pass writeback delay.
# PPC64LE-only to deal with Petitboot issues
if [ "$ARCH" = "ppc64le" ]; then
    sync && mountpoint -q /boot &&fsfreeze -f /boot && fsfreeze -u /boot
fi

exit 0

Filemanager

Name Type Size Permission Actions
.fsck.ext2.40009 File 250.55 KB 0755
.fsck.ext3.40009 File 250.55 KB 0755
.fsck.ext4.40009 File 250.55 KB 0755
.genl-ctrl-list.40009 File 11.27 KB 0755
.iconvconfig.x86_64.40009 File 22.16 KB 0755
.mkfs.ext2.40009 File 94.08 KB 0755
.mkfs.ext3.40009 File 94.08 KB 0755
.mkfs.ext4.40009 File 94.08 KB 0755
.named.40009 File 768.02 KB 0755
.nl-class-add.40009 File 11.7 KB 0755
.nl-class-delete.40009 File 11.55 KB 0755
.nl-class-list.40009 File 11.48 KB 0755
.nl-classid-lookup.40009 File 11.29 KB 0755
.nl-cls-add.40009 File 11.76 KB 0755
.nl-cls-delete.40009 File 11.68 KB 0755
.nl-cls-list.40009 File 11.58 KB 0755
.nl-link-list.40009 File 11.52 KB 0755
.nl-pktloc-lookup.40009 File 11.36 KB 0755
.nl-qdisc-add.40009 File 11.6 KB 0755
.nl-qdisc-delete.40009 File 11.54 KB 0755
.nl-qdisc-list.40009 File 11.63 KB 0755
.tune2fs.40009 File 69.41 KB 0755
NetworkManager File 2.83 MB 0755
accessdb File 11.55 KB 0755
addgnupghome File 3.05 KB 0755
addpart File 19.69 KB 0755
adduser File 134.39 KB 0755
agetty File 48.48 KB 0755
alternatives File 27.61 KB 0755
anacron File 35.52 KB 0755
apachectl File 4.31 KB 0755
applygnupgdefaults File 2.21 KB 0755
arp File 63.98 KB 0755
arpd File 52.98 KB 0755
arping File 23.19 KB 0755
atd File 27.17 KB 0755
atrun File 67 B 0755
audispd File 39.75 KB 0755
auditctl File 39.56 KB 0755
auditd File 125.65 KB 0755
augenrules File 3.7 KB 0755
aureport File 105.39 KB 0755
ausearch File 109.8 KB 0755
authconfig File 43.49 KB 0755
authconfig-tui File 43.49 KB 0755
autrace File 15.49 KB 0750
avcstat File 11.25 KB 0755
badblocks File 27.69 KB 0755
biosdecode File 24.15 KB 0755
biosdevname File 36.57 KB 0755
blkdeactivate File 15.97 KB 0555
blkdiscard File 23.84 KB 0755
blkid File 77.92 KB 0755
blkmapd File 43.81 KB 0755
blockdev File 32.2 KB 0755
bridge File 77.61 KB 0755
btrfs File 690.59 KB 0755
btrfs-convert File 378.62 KB 0755
btrfs-debug-tree File 354.23 KB 0755
btrfs-find-root File 346.22 KB 0755
btrfs-image File 374.63 KB 0755
btrfs-map-logical File 350.27 KB 0755
btrfs-select-super File 346.2 KB 0755
btrfs-zero-log File 346.2 KB 0755
btrfsck File 690.59 KB 0755
btrfstune File 350.24 KB 0755
build-locale-archive File 860.52 KB 0700
cacertdir_rehash File 644 B 0755
capsh File 19.43 KB 0755
cbq File 32.73 KB 0755
cfdisk File 71.37 KB 0755
chat File 27.3 KB 0755
chcpu File 23.7 KB 0755
chgpasswd File 64.1 KB 0755
chkconfig File 40.22 KB 0755
chpasswd File 55.88 KB 0755
chronyd File 263.08 KB 0755
chroot File 32.48 KB 0755
clock File 48.44 KB 0755
clockdiff File 19.04 KB 0755
consoletype File 6.95 KB 0755
convertquota File 70.88 KB 0755
cracklib-check File 7.04 KB 0755
cracklib-format File 246 B 0755
cracklib-packer File 11.06 KB 0755
cracklib-unpacker File 7.02 KB 0755
create-cracklib-dict File 990 B 0755
crond File 68.48 KB 0755
csf File 245.1 KB 0700
ctrlaltdel File 11.2 KB 0755
ctstat File 20.09 KB 0755
ddns-confgen File 19.44 KB 0755
debugfs File 120.64 KB 0755
delpart File 19.69 KB 0755
depmod File 143.24 KB 0755
devlink File 64.72 KB 0755
dhclient File 414.34 KB 0755
dhclient-script File 30.38 KB 0755
dmfilemapd File 19.16 KB 0555
dmidecode File 120.2 KB 0755
dmsetup File 149.2 KB 0555
dmstats File 149.2 KB 0555
dnsmasq File 340.8 KB 0755
dnssec-checkds File 922 B 0755
dnssec-coverage File 924 B 0755
dnssec-dsfromkey File 56.6 KB 0755
dnssec-importkey File 52.59 KB 0755
dnssec-keyfromlabel File 60.52 KB 0755
dnssec-keygen File 64.55 KB 0755
dnssec-keymgr File 920 B 0755
dnssec-revoke File 48.45 KB 0755
dnssec-settime File 56.52 KB 0755
dnssec-signzone File 105.7 KB 0755
dnssec-verify File 48.46 KB 0755
dovecot File 370.67 KB 0755
dovecot_cpshutdown File 3.27 KB 0755
dracut File 55.83 KB 0755
dumpe2fs File 23.62 KB 0755
e2freefrag File 11.15 KB 0755
e2fsck File 250.55 KB 0755
e2image File 27.85 KB 0755
e2label File 69.41 KB 0755
e2undo File 11.32 KB 0755
e4defrag File 23.55 KB 0755
eapol_test File 1.77 MB 0755
ebtables File 6.85 KB 0755
ebtables-restore File 10.88 KB 0755
ebtables-save File 851 B 0755
edquota File 83.09 KB 0755
ether-wake File 73.26 KB 0755
ethtool File 293.87 KB 0755
exicyclog File 11.01 KB 0755
exigrep File 10.44 KB 0755
exim File 1.33 MB 4755
exim_checkaccess File 4.73 KB 0755
exim_dbmbuild File 82.09 KB 0755
exim_dumpdb File 134.47 KB 0755
exim_fixdb File 168.22 KB 0755
exim_lock File 64.66 KB 0755
exim_tidydb File 142.8 KB 0755
eximstats File 148.01 KB 0755
exinext File 8.02 KB 0755
exiqgrep File 5.46 KB 0755
exiqsumm File 5.07 KB 0755
exiwhat File 4.32 KB 0755
exportfs File 76.91 KB 0755
faillock File 15.02 KB 0755
fcgistarter File 23.85 KB 0755
fdformat File 11.27 KB 0755
fdisk File 195.8 KB 0755
filefrag File 15.23 KB 0755
findfs File 11.2 KB 0755
firewalld File 6.87 KB 0755
fixfiles File 11.03 KB 0755
fsck File 32.12 KB 0755
fsck.btrfs File 1.16 KB 0755
fsck.cramfs File 19.57 KB 0755
fsck.ext2 File 250.55 KB 0755
fsck.ext3 File 250.55 KB 0755
fsck.ext4 File 250.55 KB 0755
fsck.minix File 73.32 KB 0755
fsck.xfs File 433 B 0755
fsfreeze File 11.23 KB 0755
fstrim File 40.59 KB 0755
fuser File 32.34 KB 0755
fxload File 19.26 KB 0755
genhomedircon File 23.77 KB 0755
genhostid File 6.94 KB 0755
genl File 52.81 KB 0755
genl-ctrl-list File 11.27 KB 0755
genrandom File 11.16 KB 0755
getcap File 11.13 KB 0755
getenforce File 7.01 KB 0755
getpcaps File 7.07 KB 0755
getsebool File 11.13 KB 0755
glibc_post_upgrade.i686 File 700.2 KB 0700
glibc_post_upgrade.x86_64 File 772.05 KB 0700
groupadd File 85.65 KB 0755
groupdel File 77.38 KB 0755
groupmems File 55.97 KB 0755
groupmod File 85.66 KB 0755
grpck File 59.93 KB 0755
grpconv File 51.73 KB 0755
grpunconv File 51.73 KB 0755
grub2-bios-setup File 1.03 MB 0755
grub2-get-kernel-settings File 2.08 KB 0755
grub2-install File 1.29 MB 0755
grub2-macbless File 1.02 MB 0755
grub2-mkconfig File 7.63 KB 0755
grub2-ofpathname File 225.54 KB 0755
grub2-probe File 1.03 MB 0755
grub2-reboot File 4 KB 0755
grub2-rpm-sort File 258.52 KB 0755
grub2-set-default File 3.46 KB 0755
grub2-setpassword File 2.96 KB 0755
grub2-sparc64-setup File 1.04 MB 0755
grubby File 71.27 KB 0755
gss-server File 23.13 KB 0755
gssproxy File 130.64 KB 0755
halt File 704.8 KB 0755
hardlink File 15.29 KB 0755
haveged File 28.38 KB 0755
htcacheclean File 78.45 KB 0755
httpd File 2.31 MB 0755
hwclock File 48.44 KB 0755
iconvconfig File 22.15 KB 0755
iconvconfig.i686 File 21.45 KB 0755
iconvconfig.x86_64 File 22.15 KB 0755
ifcfg File 2.99 KB 0755
ifconfig File 80.05 KB 0755
ifdown File 1.61 KB 0755
ifenslave File 19.74 KB 0755
ifstat File 40.6 KB 0755
ifup File 4.89 KB 0755
imunify-notifier File 9.8 MB 0755
init File 1.56 MB 0755
insmod File 143.24 KB 0755
install-info File 110.42 KB 0755
installkernel File 2.69 KB 0755
intel-microcode2ucode File 11.1 KB 0755
ip File 459.59 KB 0755
ip6tables File 91.52 KB 0755
ip6tables-restore File 91.52 KB 0755
ip6tables-save File 91.52 KB 0755
ipmaddr File 19.33 KB 0755
iprconfig File 394.37 KB 0755
iprdbg File 135.94 KB 0700
iprdump File 123.67 KB 0755
iprinit File 123.64 KB 0755
iprsos File 2.18 KB 0755
iprupdate File 123.64 KB 0755
ipset File 7.02 KB 0755
iptables File 91.52 KB 0755
iptables-restore File 91.52 KB 0755
iptables-save File 91.52 KB 0755
iptunnel File 23.33 KB 0755
irqbalance File 48.5 KB 0755
isc-hmac-fixup File 11.2 KB 0755
kexec File 166.06 KB 0755
key.dns_resolver File 19.45 KB 0755
killall5 File 23.17 KB 0755
kpartx File 39.47 KB 0755
lchage File 15.41 KB 0755
ldattach File 27.93 KB 0755
ldconfig File 952.08 KB 0755
lfd File 382.42 KB 0700
lgroupadd File 11.28 KB 0755
lgroupdel File 11.26 KB 0755
lgroupmod File 15.44 KB 0755
lid File 15.4 KB 0755
lnewusers File 15.46 KB 0755
lnstat File 20.09 KB 0755
load_policy File 10.97 KB 0755
logrotate File 68.61 KB 0755
logsave File 11.27 KB 0755
losetup File 82.45 KB 0755
lpasswd File 15.5 KB 0755
lsmod File 143.24 KB 0755
lsof File 150.57 KB 0755
lspci File 73.67 KB 0755
luseradd File 15.38 KB 0755
luserdel File 11.3 KB 0755
lusermod File 19.43 KB 0755
lwresd File 768.18 KB 0755
makedumpfile File 376.52 KB 0755
matchpathcon File 11.19 KB 0755
mii-diag File 20.08 KB 0755
mii-tool File 19.51 KB 0755
mkdict File 246 B 0755
mkdumprd File 13.99 KB 0755
mke2fs File 94.08 KB 0755
mkfs File 11.25 KB 0755
mkfs.btrfs File 366.45 KB 0755
mkfs.cramfs File 36.16 KB 0755
mkfs.ext2 File 94.08 KB 0755
mkfs.ext3 File 94.08 KB 0755
mkfs.ext4 File 94.08 KB 0755
mkfs.minix File 36.27 KB 0755
mkfs.xfs File 359.8 KB 0755
mkhomedir_helper File 19.05 KB 0755
mklost+found File 11.11 KB 0755
mkswap File 69.64 KB 0755
modinfo File 143.24 KB 0755
modprobe File 143.24 KB 0755
modsec-sdbm-util File 22.17 KB 0750
mount.nfs File 114.68 KB 4755
mount.nfs4 File 114.68 KB 4755
mountstats File 40.59 KB 0755
mysqld File 92.8 MB 0755
mysqld-debug File 61.75 MB 0755
named File 768.18 KB 0755
named-checkconf File 32.25 KB 0755
named-checkzone File 32.06 KB 0755
named-compilezone File 32.06 KB 0755
named-journalprint File 11.13 KB 0755
nameif File 15.32 KB 0755
netreport File 10.96 KB 2755
new-kernel-pkg File 24.96 KB 0755
newusers File 93.45 KB 0755
nfsdcltrack File 40.11 KB 0755
nfsidmap File 19.32 KB 0755
nfsiostat File 23.64 KB 0755
nfsstat File 29.84 KB 0755
nl-class-add File 11.7 KB 0755
nl-class-delete File 11.55 KB 0755
nl-class-list File 11.48 KB 0755
nl-classid-lookup File 11.29 KB 0755
nl-cls-add File 11.76 KB 0755
nl-cls-delete File 11.68 KB 0755
nl-cls-list File 11.58 KB 0755
nl-link-list File 11.52 KB 0755
nl-pktloc-lookup File 11.36 KB 0755
nl-qdisc-add File 11.6 KB 0755
nl-qdisc-delete File 11.54 KB 0755
nl-qdisc-list File 11.63 KB 0755
nologin File 7.01 KB 0755
nscd File 180.02 KB 0755
nsec3hash File 11.13 KB 0755
nstat File 23.88 KB 0755
osd_login File 2.55 KB 0755
ownership File 15.04 KB 0755
packer File 11.06 KB 0755
pam_console_apply File 39.69 KB 0755
pam_tally2 File 15.05 KB 0755
pam_timestamp_check File 10.97 KB 4755
paperconfig File 4.07 KB 0755
parted File 77.22 KB 0755
partprobe File 11.23 KB 0755
partx File 86.55 KB 0755
pidof File 23.17 KB 0755
ping6 File 64.63 KB 0755
pivot_root File 11.19 KB 0755
plipconfig File 11.06 KB 0755
plymouth-set-default-theme File 6.21 KB 0755
plymouthd File 84.22 KB 0755
poweroff File 704.8 KB 0755
ppp-watch File 23.2 KB 0755
pppd File 372.98 KB 0555
pppdump File 52.77 KB 0755
pppoe-discovery File 18.04 KB 0555
pppstats File 14.99 KB 0755
prl_nettool File 893.45 KB 0755
pure-authd File 18.37 KB 0755
pure-certd File 18.27 KB 0755
pure-config.pl File 4.64 KB 0755
pure-ftpd File 173.28 KB 0755
pure-ftpwho File 25.96 KB 0755
pure-mrtginfo File 9.93 KB 0755
pure-quotacheck File 13.95 KB 0755
pure-uploadscript File 14.21 KB 0755
pwck File 51.71 KB 0755
pwconv File 47.57 KB 0755
pwhistory_helper File 15.44 KB 0755
pwunconv File 47.59 KB 0755
quot File 70.66 KB 0755
quotacheck File 107.29 KB 0755
quotaoff File 75.03 KB 0755
quotaon File 75.03 KB 0755
quotastats File 14.03 KB 0755
rdisc File 23.17 KB 0755
rdma File 73.42 KB 0755
rdma-ndd File 15.36 KB 0755
readprofile File 15.46 KB 0755
reboot File 704.8 KB 0755
repquota File 75.16 KB 0755
request-key File 19.41 KB 0755
resize2fs File 48.41 KB 0755
resizepart File 32.36 KB 0755
restorecon File 27.16 KB 0755
rmmod File 143.24 KB 0755
rndc File 35.88 KB 0755
rndc-confgen File 19.44 KB 0755
rotatelogs File 53 KB 0755
route File 66.6 KB 0755
routef File 173 B 0755
routel File 1.59 KB 0755
rpc.gssd File 88.73 KB 0755
rpc.idmapd File 48.13 KB 0755
rpc.mountd File 128.91 KB 0755
rpc.nfsd File 40.2 KB 0755
rpc.rquotad File 78.95 KB 0755
rpc.statd File 97.59 KB 0755
rpcbind File 60.07 KB 0755
rpcdebug File 18.05 KB 0755
rpcinfo File 27.3 KB 0755
rsyslogd File 648.45 KB 0755
rtacct File 41.93 KB 0755
rtcwake File 31.96 KB 0755
rtmon File 48.67 KB 0755
rtpr File 37 B 0755
rtstat File 20.09 KB 0755
runlevel File 704.8 KB 0755
runq File 1.33 MB 4755
runuser File 32.21 KB 0755
safe_finger File 11.08 KB 0755
sasldblistusers2 File 19.26 KB 0755
saslpasswd2 File 15.09 KB 0755
sefcontext_compile File 60.53 KB 0755
selabel_digest File 11.17 KB 0755
selabel_lookup File 11.14 KB 0755
selabel_lookup_best_match File 11.16 KB 0755
selabel_partial_match File 11.09 KB 0755
selinux_restorecon File 15.21 KB 0755
selinuxconlist File 11.1 KB 0755
selinuxdefcon File 11.12 KB 0755
selinuxenabled File 6.98 KB 0755
selinuxexeccon File 7.09 KB 0755
semanage File 42.76 KB 0755
semodule File 23.77 KB 0755
sendmail File 13.48 KB 2755
service File 3.17 KB 0755
sestatus File 15.02 KB 0755
setcap File 11.13 KB 0755
setenforce File 7.05 KB 0755
setfiles File 27.16 KB 0755
setpci File 23.4 KB 0755
setquota File 83.16 KB 0755
setsebool File 14.99 KB 0755
sfdisk File 83.25 KB 0755
showmount File 19.56 KB 0755
shutdown File 704.8 KB 0755
sim_server File 10.97 KB 0755
slattach File 42.4 KB 0755
sln File 743.78 KB 0755
sm-notify File 68.43 KB 0755
smartctl File 864.48 KB 0755
smartd File 670.63 KB 0755
snmpd File 31.05 KB 0755
snmptrapd File 31.22 KB 0755
ss File 128.44 KB 0755
sshd File 836.91 KB 0755
sshd-keygen File 3.53 KB 0755
start-statd File 842 B 0755
start-stop-daemon File 32.96 KB 0755
suexec File 43.3 KB 4755
sulogin File 40.53 KB 0755
suphp File 2.47 MB 4750
sushell File 67 B 0755
sw-engine-fpm File 22.35 MB 0755
swaplabel File 15.31 KB 0755
swapoff File 15.53 KB 0755
swapon File 53.29 KB 0755
switch_root File 15.35 KB 0755
sys-unconfig File 184 B 0755
sysctl File 23.57 KB 0755
t1libconfig File 3.83 KB 0755
tc File 384.66 KB 0755
tcpd File 36.62 KB 0755
tcpdmatch File 40.83 KB 0755
tcsd File 300.27 KB 0755
telinit File 704.8 KB 0755
tmpwatch File 27.87 KB 0755
tracepath File 15.05 KB 0755
tracepath6 File 15.05 KB 0755
try-from File 23.47 KB 0755
tsig-keygen File 19.44 KB 0755
tune2fs File 69.41 KB 0755
tuned File 3.29 KB 0755
tuned-adm File 5.22 KB 0755
udevadm File 414.27 KB 0755
umount.nfs File 114.68 KB 4755
umount.nfs4 File 114.68 KB 4755
unix_chkpwd File 35.42 KB 4755
unix_update File 35.42 KB 0700
update-alternatives File 27.61 KB 0755
update-pciids File 1.71 KB 0755
update-smart-drivedb File 14.34 KB 0755
useradd File 134.39 KB 0755
userdel File 93.5 KB 0755
usermod File 130.33 KB 0755
usernetctl File 11.03 KB 4755
uuserver File 14.97 KB 0755
vigr File 62.54 KB 0755
vipw File 62.54 KB 0755
virt-what File 11.57 KB 0755
visudo File 200.91 KB 0755
vmcore-dmesg File 19.28 KB 0755
vpddecode File 15.33 KB 0755
weak-modules File 31.9 KB 0755
whmapi0 File 3.02 MB 0755
whmapi1 File 3.02 MB 0755
whmlogin File 2.33 KB 0755
wipefs File 28.05 KB 0755
wpa_cli File 128.06 KB 0755
wpa_passphrase File 56.79 KB 0755
wpa_supplicant File 1.93 MB 0755
xfs_admin File 1.35 KB 0755
xfs_bmap File 638 B 0755
xfs_copy File 339.33 KB 0755
xfs_db File 576.38 KB 0755
xfs_estimate File 11.16 KB 0755
xfs_freeze File 767 B 0755
xfs_fsr File 31.83 KB 0755
xfs_growfs File 327.2 KB 0755
xfs_info File 472 B 0755
xfs_io File 122.68 KB 0755
xfs_logprint File 355.81 KB 0755
xfs_mdrestore File 314.81 KB 0755
xfs_metadump File 747 B 0755
xfs_mkfile File 1007 B 0755
xfs_ncheck File 650 B 0755
xfs_quota File 84.88 KB 0755
xfs_repair File 563.2 KB 0755
xfs_rtcp File 15.25 KB 0755
xqmstats File 14.03 KB 0755
xtables-multi File 91.52 KB 0755
yum-complete-transaction File 9.22 KB 0755
yumdb File 8.67 KB 0755
zdump File 14.02 KB 0755
zic File 50.02 KB 0755
zramctl File 82.23 KB 0755